# What is Botpress

In doubt about Botpress? This page is for you. Let's start demystifying what botpress is exactly!

## What Botpress is not

- A SaaS Bot building platform
- A no-coding bot building platform
- A code-from-scratch bot building platform
- In competition with other bot building tools
- Extremely hard to use and reserved for PhD's
- A side project that will be abandoned in a few weeks
- A cure for cancer

## What Botpress is

- A code-first bot building platform
- On-premise (i.e. runs locally, host it yourself)
- Modular & open-source (don't reinvent the wheel)
- Community-focused. We want everybody to contribute and create modules.
- Leveraging as many other tools as possible
- Easy to learn and feeling natural for node developers
- A serious project backed by a real company
- Highly productive

## What you get by using Botpress

Before creating Botpress, we created many bots using all the tools available on the market. What we found is that when you build a bot, you basically have the choice between using a SaaS platform (like Chatfuel, FlowXO, Motion.ai) or coding a bot from scratch. Let's look at why both don't work:

- The SaaS thing looks interesting because it's very easy to get started and requires no coding skills. The problems come when you want to get your bot to do things that aren't supported by the SaaS or if you want to customize the overall experience. Some platforms let you call APIs to run custom code, but this defies the purpose of being hassle-free and not requiring coding.

- Coding a bot from scratch is often the first reflex for developers. Sure, it takes a bit longer and we need to learn how things work. But that's what makes us programmers. We like to create things ourselves, and that's fine! But... how am I supposed to schedule broadcasts? Fetch and cache user profiles? Save and process customer orders? Add Human-in-the-loop capabilities? See where my bot messed up in production? Edit the content live without redeploying the bot? Do A/B testing? Hmmmm..

That's why we created Botpress. We combined all the advantages of the SaaS and the "from Scratch" into an easy-to-use modular framework. All these things that would take you weeks to implement from scratch are available as Botpress Modules. Everything is accessible from a rich graphical interface, so once your bot is coded, literally anybody can manage it.

The philosophy behind botpress is that if there's something you want your bot to do and that thing is not specific to only your bot, then **there should be a module for it**. If there isn't, then we hope that you will take the time to make a positive contribution to the community and **create the missing module**.